﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace RefactorMessages
{
    [Serializable]
    public class Messages
    {
        // if not setting to "MessagesByType", a parent node of <MessagesByTypes> 
        // beyonds <MessagesByType> will be generated
        [XmlElement("MessagesByType")]
        public List<MessagesByType> MessagesByTypes { get; set; }
    }

    [Serializable]
    public class MessagesByType
    {
        [XmlElement("Message")]
        public List<Message> Messages { get; set; }

        [XmlAttribute]
        public string typeCode { get; set; }
        [XmlAttribute]
        public string typeName { get; set; }
    }

    [Serializable]
    public class Variable
    {
        [XmlAttribute]
        public string formatIndex { get; set; }
        [XmlText]
        public string text { get; set; }
    }

    [Serializable]
    public class Message
    {
        [XmlIgnore]
        [XmlAttribute]
        public string category { get; set; }
        [XmlAttribute]
        public string id { get; set; }
        [XmlIgnore]
        [XmlAttribute]
        public string old_id { get; set; }
        [XmlIgnore]
        public string TypeName { get; set; }
        [XmlIgnore]
        public string TypeCode { get; set; }
        [XmlIgnore]
        public string ClassName { get; set; }
        public string EventId { get; set; }
        public string Code { get; set; }
        public string ShortText { get; set; }
        public string Description { get; set; }
        public List<Variable> Variables { get; set; }
    }
}
